// Modulo_Ventas para programa SQ
// Creado por Claudio Ricardo Folgán 09/2020

#include <hmg.ch>

Declare Window Main

Function Modulo_Ventas

	If IsWindowActive (Ventas)

		DoMethod ("Ventas" , " SetFocus ")

	Else
	
		Load Window Ventas
		
			Select Tickets
			
				nTicket := Tickets->Ticket
				
			Select TmpVenta
			
				Zap
				
				
				SetProperty ("Ventas" , "Label_Ticket" , "Value" , nTicket)
				SetProperty ("Ventas" , "Label_Cliente" , "Value" , "000-Consumidor Final")

				On Key Up Of Ventas Action On_Key_Up_Action ()
				On Key Down Of Ventas Action On_Key_Down_Action ()
				
		Ventas. Center
		Ventas. Activate
		
	EndIf

Return Nil
//---------------------------------------------------------------------------------------------------------------//
//---------------------------------------------------------------------------------------------------------------//

Function Ventas_Button_Cliente_Action

	Bloquea_Botones_Ventas ()
	
		Datos_Cliente_Seleccionado ()

	DesBloquea_Botones_Ventas ()
	
	DoMethod ("Ventas" , "Text_Codigo" , " SetFocus ")
	
	
	If ! Empty (paArrayCliente)

		cCliente := AllTrim (paArrayCliente [1]) + " " + AllTrim (paArrayCliente [2])
		
		SetProperty ("Ventas" , "Label_Cliente" , "Value" , cCliente)

		paArrayCliente := {}
		
	EndIf
	
Return Nil
//---------------------------------------------------------------------------------------------------------------//
//---------------------------------------------------------------------------------------------------------------//

Function Ventas_Spinner_Cantidad_OnChange

	DoMethod ("Ventas" , "Text_Codigo" , " SetFocus ")

Return Nil
//---------------------------------------------------------------------------------------------------------------//
//---------------------------------------------------------------------------------------------------------------//

Function Ventas_Text_Codigo_OnEnter

LOCAL cCodigo := AllTrim (GetProperty ("Ventas" , "Text_Codigo" , "Value"))
LOCAL nCant := GetProperty ("Ventas" , "Spinner_Cantidad" , "Value")
LOCAL nTicket := Val (AllTrim (GetProperty ("Ventas" , "Label_Ticket" , "Value")))
LOCAL nCosto := 0

	If ! Empty (cCodigo)
	
		Select Articulos
			Index On Codigo To Icode
			
				If DbSeek (cCodigo, .F.)
				
					paArrayArticulo := {Articulos->Codigo,Articulos->Rub,Articulos->Articulo,Articulos->PVP,;
										Articulos->Stock,Articulos->Stk_Min,Articulos->Costo,Articulos->Proveedor,;
										Articulos->Observac,Articulos->P,Articulos->ID,Articulos->Descuenta}

				Else
				
					MsgStop ("El Código ingresado NO se encuentra en la Base de Datos !" , "Atención !!!")

					Return Nil
					
				EndIf

				If paArrayArticulo [10]					// Si es un preparado calculo el costo
				
					Select Primas
					
						DbGoTop ()
						
						DO While .NOT. EoF ()
						
							If Primas->ID == paArrayArticulo [11]	// Si encuentra la Materia Prima
							
								nCosto := Primas->Costo * paArrayArticulo [12]
								
								Exit
								
							Else
							
								Skip
								
							EndIf
							
						EndDo
						
				Else
				
					nCosto := paArrayArticulo [7]

				EndIf


		If ! Empty (paArrayArticulo)
		
			Select TmpVenta
			
				Append Blank
				
					Replace Codigo With paArrayArticulo [1], Rub With paArrayArticulo [2]
					Replace Articulo With paArrayArticulo [3], PVP With paArrayArticulo [4]
					Replace Cant With nCant, SubTotal With paArrayArticulo [4] * nCant
					Replace Costo With nCosto * nCant, Ticket With nTicket
					Replace P With paArrayArticulo [10], ID With paArrayArticulo [11]
					Replace Descuenta With paArrayArticulo [12] * nCant

						Commit

						If Recno () == 30
						
							MsgStop ("Ha llegado al límite de Artículos (30) imprimibles en UNA factura" + CRLF + ;
									"Si no desea imprimirla puede continuar ingresando artículos" + CRLF + ;
									"Si va a imprimir cierre ahora la venta y comience una nueva" + CRLF + ;
									"con el resto de Artículos !" , "Atención !!!")						
						
						EndIf
						
			paArrayArticulo := {}

			DoMethod ("Ventas" , "Browse_TmpVenta" , " Refresh ")

				Sum Cant, SubTotal To nCantidad, nParcial
				
			SetProperty ("Ventas" , "Label_Articulos" , "Value" , nCantidad)
			SetProperty ("Ventas" , "Label_Total" , "Value" , nParcial)
			SetProperty ("Ventas" , "Text_Codigo" , "Value" , "")
			SetProperty ("Ventas" , "Spinner_Cantidad" , "Value" , 1)

			DoMethod ("Ventas" , "Text_Codigo" , " SetFocus ")
			
		EndIf
		
	EndIf
	
Return Nil
//---------------------------------------------------------------------------------------------------------------//
//---------------------------------------------------------------------------------------------------------------//

Function Ventas_Button_Articulo_Action

	Bloquea_Botones_Ventas ()

		Datos_Articulo_Seleccionado ()
		
	DesBloquea_Botones_Ventas ()
	

	If ! Empty (paArrayArticulo)

		cCodigo := AllTrim (paArrayArticulo [1])
		
		SetProperty ("Ventas" , "Text_Codigo" , "Value" , cCodigo)

		Ventas_Text_Codigo_OnEnter ()
		
	EndIf

Return Nil
//---------------------------------------------------------------------------------------------------------------//
//---------------------------------------------------------------------------------------------------------------//

Function Ventas_Browse_TmpVenta_OnDblClick				// Borrar el registro seleccionado

LOCAL cArticulo := ""

	Select TmpVenta

		cArticulo := TmpVenta->Articulo
		
		If MsgYesNo ("Está seguro de querer borrar el item seleccionado:" + CRLF + CRLF + ;
						cArticulo + CRLF + CRLF + ;
						"de la operación de venta ?" , "Atención !")
	
			Delete
				Pack
				
				Sum Cant, SubTotal To nCantidad, nParcial

			DoMethod ("Ventas" , "Browse_TmpVenta" , " Refresh ")
			SetProperty ("Ventas" , "Browse_TmpVenta" , "Value" , 1)

			SetProperty ("Ventas" , "Label_Articulos" , "Value" , nCantidad)
			SetProperty ("Ventas" , "Label_Total" , "Value" , nParcial)
			SetProperty ("Ventas" , "Text_Codigo" , "Value" , "")
			SetProperty ("Ventas" , "Spinner_Cantidad" , "Value" , 1)

			DoMethod ("Ventas" , "Text_Codigo" , " SetFocus ")
		
		EndIf

Return Nil
//---------------------------------------------------------------------------------------------------------------//
//---------------------------------------------------------------------------------------------------------------//

Function Ventas_Button_Cerrar_Action					// Cerrar venta

LOCAL nTicket := Val ( GetProperty ("Ventas" , "Label_Ticket" , "Value"))
LOCAL nTotal := Val ( GetProperty ("Ventas" , "Label_Total" , "Value"))
LOCAL cCodigo, cArticulo := ""
LOCAL nRubro, nCant, nSubTotal := 0

	If Val ( AllTrim ( GetProperty ("Ventas" , "Label_Total" , "Value"))) = 0
	
		MsgStop ("No se puede cerrar un operación de venta vacía !" , "Atención !!!")
		
		Return Nil
		
	EndIf

	If IsWindowActive (Finalizar)				// Si estaba abierta la cierro
	
		DoMethod ("Finalizar" , "Release")
		
		Inkey (1)
		
	EndIf
	
	Load Window Finalizar
	
		SetProperty ("Finalizar" , "Label_Total" , "Value" , AllTrim (Str (nTotal)))
		SetProperty ("Finalizar" , "Text_Descuento" , "Value" , 0)
		SetProperty ("Finalizar" , "Text_Total_Cobrar" , "Value" , nTotal)
		SetProperty ("Finalizar" , "Label_Vuelto" , "Value" , AllTrim (Str (0 - nTotal)))

			DoMethod ("Finalizar" , "Text_AbonaCon" , "SetFocus")
	
	Finalizar. Center
	Finalizar. Activate

Return Nil
//---------------------------------------------------------------------------------------------------------------//

Function Finalizar_Text_Descuento_OnChange

LOCAL nTotal := Val ( GetProperty ("Finalizar" , "Label_Total" , "Value"))
LOCAL nDescuento := GetProperty ("Finalizar" , "Text_Descuento" , "Value")
LOCAL nCobrar := nTotal - ((nTotal * nDescuento) / 100)

	SetProperty ("Finalizar" , "Text_Total_Cobrar" , "Value" , nCobrar)

	
Return Nil
//---------------------------------------------------------------------------------------------------------------//

Function Finalizar_Text_AbonaCon_OnChange

LOCAL nTotal := GetProperty ("Finalizar" , "Text_Total_Cobrar" , "Value")
LOCAL nAbona := GetProperty ("Finalizar" , "Text_AbonaCon" , "Value")
LOCAL nVuelto := nAbona - nTotal

	SetProperty ("Finalizar" , "Label_Vuelto" , "Value" , AllTrim (Str (nVuelto)))

Return Nil
//---------------------------------------------------------------------------------------------------------------//

Function Guardar_Venta (lParametro)			// Parametro enviado desde botones Cerrar (ventana Finalizar)
											// .F. = Solo guardar  -  .T. Guardar y generar PDF

LOCAL cCliente := AllTrim ( GetProperty ("Ventas" , "Label_Cliente" , "Value"))
LOCAL nTotal := GetProperty ("Finalizar" , "Text_Total_Cobrar" , "Value")
LOCAL cCodigo, cArticulo := ""
LOCAL nRubro, nCant, nSubTotal, nCosto, nTicket := 0
LOCAL nDescuento := GetProperty ("Finalizar" , "Text_Descuento" , "Value")

	Finalizar. Release

	Select TmpVenta

		DbGoBottom ()

			Replace Desc With nDescuento, Total With nTotal
				Commit
				
		DbGoTop ()
		
		DO While .NOT. EoF ()

			cCodigo := TmpVenta->Codigo
			nRubro := TmpVenta->Rub
			cArticulo := TmpVenta->Articulo
			nCant := TmpVenta->Cant
			nSubTotal := TmpVenta->SubTotal
			nTicket := TmpVenta->Ticket
			nCosto := TmpVenta->Costo

			lPreparado := TmpVenta->P
			nID := TmpVenta->ID
			nDescuenta := TmpVenta->Descuenta

			Select Ventas										// Guarda la Venta realizada
			
				Append Blank
				
					Replace Ticket With nTicket, Fecha With Date (), Articulo With cArticulo
					Replace Cant With nCant, SubTotal With nSubTotal, Codigo With cCodigo
					Replace Rub With nRubro, Costo With nCosto
					
																// Descuenta Stocks

			If lPreparado										// Si es un producto preparado
			
				Select Primas
				
					Go Top
					
					DO While .NOT. EoF ()
					
						If Primas->ID == nID
						
							Replace Litros With Litros - nDescuenta
							
							Commit
							
							Exit

						EndIf
						
						Skip
						
					EndDo
			
			Else
			
				Select Articulos
				
					Go Top
					
					DO While .NOT. EoF ()
					
						If Articulos->Codigo == cCodigo
						
							Replace Stock With Stock - nCant
							
							Commit
							
							Exit

						EndIf
						
						Skip
						
					EndDo

			EndIf
			
			Select TmpVenta
			
				Skip

		EndDo

		Select Ventas
		
			Go Bottom
			
				Replace Hora With Time (), Total With nTotal, Cliente With cCliente
				
					Commit
		
		Select Tickets
		
			Go Top
			
				Replace Ticket With nTicket + 1

					Commit
					
	If lParametro								// Si es .T. va a la parte de generar el PDF para imprimir
	
		Ventas. Release							// Cierra la ventana Ventas

		Select TmpVenta
		
			If LastRec () > 30					// Si tiene mas de 30 registros no se imprime
			
				MsgStop ("La operación de venta contiene más de 30 registros y NO se puede imprimir !" , "Atención !!!")
				
				Return Nil
			
			EndIf

		Generar_PDF_Venta (nTicket,cCliente)	// Genera el PDF (como nombre: el numero de ticket + .pdf)
												// además envia el nombre del cliente
		
		Return Nil
	
	EndIf
	
	Ventas. Release

Return Nil
//---------------------------------------------------------------------------------------------------------------//
//---------------------------------------------------------------------------------------------------------------//

Function Finalizar_Button_Cancelar_Action

	Finalizar. Release


Return Nil
//---------------------------------------------------------------------------------------------------------------//

Function Ventas_Button_Cancelar_Action					// Cancelar venta

	Release Key Up Of Ventas
	Release Key Down Of Ventas

	Ventas. Release

Return Nil
//---------------------------------------------------------------------------------------------------------------//
//---------------------------------------------------------------------------------------------------------------//

Function On_Key_Up_Action

LOCAL nValue := GetProperty ("Ventas" , "Spinner_Cantidad" , "Value")

	SetProperty ("Ventas" , "Spinner_Cantidad" , "Value" , nValue + 1)

	DoMethod ("Ventas" , "Text_Codigo" , " SetFocus ")

Return Nil
//---------------------------------------------------------------------------------------------------------------//

Function On_Key_Down_Action

LOCAL nValue := GetProperty ("Ventas" , "Spinner_Cantidad" , "Value")

	SetProperty ("Ventas" , "Spinner_Cantidad" , "Value" , nValue - 1)

	DoMethod ("Ventas" , "Text_Codigo" , " SetFocus ")

Return Nil
//----------------------------------------------------------------------------------------------------------//
//----------------------------------------------------------------------------------------------------------//

Function Bloquea_Botones_Ventas

	If pnShowWinWhileEdit == 1							// Public var = 1 Oculta ventana
	
		DoMethod ("Ventas" , " Hide ")
		
	Else												// Public var = 0 Inhabilita botones

		SetProperty ("Ventas" , "Button_Cliente" , "Enabled" , .F.)	
		SetProperty ("Ventas" , "Button_Articulo" , "Enabled" , .F.)	
		SetProperty ("Ventas" , "Button_Cancelar" , "Enabled" , .F.)
		SetProperty ("Ventas" , "Button_Cerrar" , "Enabled" , .F.)

	EndIf
	
Return Nil
//----------------------------------------------------------------------------------------------------------//

Function DesBloquea_Botones_Ventas

	If pnShowWinWhileEdit == 1							// Public var = 1 vuelve a mostrar ventana

		DoMethod ("Ventas" , " Show ")

	Else												// Public var = 0 Habilita botones
	
		SetProperty ("Ventas" , "Button_Cliente" , "Enabled" , .T.)	
		SetProperty ("Ventas" , "Button_Articulo" , "Enabled" , .T.)	
		SetProperty ("Ventas" , "Button_Cancelar" , "Enabled" , .T.)
		SetProperty ("Ventas" , "Button_Cerrar" , "Enabled" , .T.)

	EndIf
	
Return Nil
//----------------------------------------------------------------------------------------------------------//
//----------------------------------------------------------------------------------------------------------//